# std::weak_ptr::operator=

From cppreference.com
< cpp‎ | memory‎ | weak ptr

weak_ptr& operator=( const weak_ptr& r ); | (1) | (since C++11)
template< class Y > weak_ptr& operator=( const weak_ptr<Y>& r ); | (2) | (since C++11)
template< class Y > weak_ptr& operator=( const shared_ptr<Y>& r ); | (3) | (since C++11)
weak_ptr& operator=( weak_ptr&& r ); | (4) | (since C++14)
template< class Y > weak_ptr& operator=( weak_ptr<Y>&& r ); | (5) | (since C++14)

Replaces the managed object with the one managed by `r`. The object is shared with `r`. If `r` manages no object, *this manages no object too.

1-3) Equivalent to std::weak_ptr<T>(r).swap(*this).
4,5) Equivalent to std::weak_ptr<T>(std::move(r)).swap(*this).

### Parameters

r | - | smart pointer to share an object with

### Return value

*this

### Exceptions

`noexcept` specification:
noexcept

### Notes

The implementation may meet the requirements without creating a temporary `weak_ptr` object.

### See also

(constructor) | creates a new `weak_ptr` (public member function)
swap | swaps the managed objects (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/weak_ptr/operator%3D&oldid=91702"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template